#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/types.h>
#include <errno.h>
#include "err.h"

#define BUFSIZE 100

int   shmid = -1;
char* shmaddr;

void usage(void)
{
  fprintf(stderr, "\nMenu: (g)et\n");
  fprintf(stderr, "      (a)ttach\n");
  fprintf(stderr, "      (r)ead\n");
  fprintf(stderr, "      (w)rite\n");
  fprintf(stderr, "      (d)etach\n");
  fprintf(stderr, "      remo(v)\n");
  fprintf(stderr, "      (i)pcs\n");
  fprintf(stderr, "      (q)uit\n");
}

void shm_get()
{
  char buf[BUFSIZE];
  key_t key;
  
  printf("Key: ");
  fgets(buf, sizeof(buf) - 1, stdin);
  key = atoi(buf);

  if( (shmid = shmget(key, BUFSIZE, 0666 | IPC_CREAT)) < 0)
    syserr("shmget error");
  printf("Shared memory ID = %d\n", shmid);
}

void shm_attach()
{
  shmaddr = shmat(shmid, 0, 0);
  if ((int) shmaddr == -1) 
    syserr("shmat error");
  printf("Shared memory attached\n");
}

void shm_detach()
{
  if(shmdt(shmaddr) == -1)
    syserr("shmdt error");
  printf("Shared memory detached\n");
}

void shm_remove()
{
  if(shmctl(shmid, IPC_RMID, 0) == -1)
    syserr("shmctl error");
  printf("Shared memory removed\n");
}

void shm_read()
{
  printf("Message: %s\n",shmaddr);
}

void shm_write()
{
  printf("Message: ");  
  fgets(shmaddr, BUFSIZE - 1, stdin);
}

int main(int argc, char *argv[])
{
  char buf[BUFSIZE];

  usage();
  for(;;) {
    printf("->");
    fgets(buf, BUFSIZE - 1, stdin);    
    switch(buf[0]) {
      case 'g': 
        shm_get();
        break;
      case 'a': 
	shm_attach();
        break;
      case 'r': 
	shm_read();
        break;
      case 'w':
	shm_write();
        break;
      case 'd':
	shm_detach();
        break;
      case 'v':
	shm_remove();
        break;
      case 'i':
	system("ipcs");
        break;
      case 'q':
	exit(0);
      default: 
        usage();
    }
  }
}
